<template>
  <div id="MapEditor">
    <div id="menu" class="panel">
      <!-- Cancel & save -->
      <div id="buttons" class="panel">
        <button @click="$router.push('/admin')">Cancel</button>
        <button @click="saveMapPanel = true">Save</button>
      </div>

      <!-- Config button -->
      <div id="config" class="panel">
        <button @click="mapConfigPanel = true">Config</button>
      </div>

      <!-- Layers -->
      <div id="layers" class="panel">
        Layers:
        <div id="layerList">
          <div class="layer" v-for="(layer, index) in layers" :key="index">
            <button
              @click="
                selectedLayerNumber =
                  selectedLayerNumber === layer.id ? null : layer.id;
                wallHitboxMode = false;
              "
              title="Select layer"
              :class="selectedLayerNumber == layer.id ? 'selected' : ''"
            >
              {{ layer.id + 1 }}
            </button>
            <span
              id="playerLayer"
              v-if="index === layerBellowPlayer - 1"
              title="Layers above are above the player "
            >
              P
            </span>
          </div>
        </div>
        <div id="wallHitboxMode">
          <button
            @click="wallHitboxMode = !wallHitboxMode"
            title="Hitbox mode"
            :class="wallHitboxMode ? 'selected' : ''"
          >
            Hitbox mode
          </button>
        </div>
      </div>

      <!-- Entities -->
      <EntitySelector
        v-on:selectedEntity="selectedEntity"
        :selectedEntityName="selectedEntityName"
      />

      <!-- Set as default -->
      <span v-if="editedMapId === null" style="opacity: 0.4; font-size:0.6em">
        Save the map to set it as default
      </span>
      <button
        v-else
        @click="spawnPositionMode = !spawnPositionMode"
        :class="spawnPositionMode ? 'selected' : ''"
      >
        Set as default
      </button>
    </div>
    <div id="editor" class="panel">
      <div id="tileList">
        <TileSelector
          v-on:selectedTile="selectedTile"
          :selectedTile="selectedTileNumber"
          :disabled="selectedLayerNumber === null"
        />
      </div>
      <div id="board"></div>
    </div>

    <!-- Map save name input modal -->
    <ModalForm
      v-if="saveMapPanel"
      title="Save map"
      v-on:submit="saveMap"
      v-on:cancel="saveMapPanel = false"
    >
      <span>Map name: <input type="text" v-model="mapName" /></span>
    </ModalForm>
    <!-- Map config modal -->
    <ModalForm
      v-if="mapConfigPanel"
      :title="mapName + ' config'"
      v-on:submit="saveConfig"
      v-on:cancel="mapConfigPanel = false"
    >
      <span>
        Map size x: <input type="number" v-model="mapSizeX" step="1" min="1" max="100" />
      </span>
      <span>
        Map size y: <input type="number" v-model="mapSizeY" step="1" min="1" max="100" />
      </span>
    </ModalForm>
    <!-- Map default info msg -->
    <ModalForm
      v-if="mapSetDefaultInfoPanel"
      title="Warning: new default map"
      v-on:submit="mapSetDefaultInfoPanel = false"
      v-on:cancel="
        mapSetDefaultInfoPanel = false;
        spawnPositionMode = false;
      "
      submitBtnText="Ok"
    >
      You are going to set the game default map to the current one.<br />
      To confirm, select on the map where you want the player to spawn.
    </ModalForm>
  </div>
</template>

<script lang="ts">
/**
 * @licence
 * Copyright 2022-2022 - RPG of the Apocalypse
 * Licensed under MIT or any later version
 * Refer to the LICENSE file included.
 */

import { Component, Watch, Vue } from "vue-property-decorator";
// Import components
import TileSelector from "./TileSelector.vue";
import EntitySelector from "./Entities/EntitySelector.vue";
import ModalForm from "../../common/ModalForm.vue";
// Import services
import Phaser from "phaser";
import { editorConfig, EditorScene } from "./editor";
import { world } from "@/services/backends";
import store from "@/store";
import { MessageType, commit } from "@/store/messages";

interface Layer {
  id: number;
}

@Component({
  components: {
    TileSelector,
    EntitySelector,
    ModalForm
  }
})
export default class MapEditor extends Vue {
  // Constants
  readonly layersNumber = 5;
  readonly layerBellowPlayer = 3;
  readonly layers: Layer[] = [];

  // Editor config
  mapSizeX = 25;
  mapSizeY = 20;

  game?: Phaser.Game;

  // Selections
  selectedLayerNumber: number | null = 0;
  selectedTileNumber: number | null = null;
  selectedEntityName: string | null = null;
  wallHitboxMode = false;
  spawnPositionMode = false;

  saveMapPanel = false;
  mapName = "New map";
  mapConfigPanel = false;
  mapSetDefaultInfoPanel = false;

  editedMapId: string | null = null;

  // Init layers
  created(): void {
    // Init the layer btns according to the layer number
    for (let i = 0; i < this.layersNumber; i++) {
      this.layers.push({ id: i });
    }
  }

  // Init game
  mounted(): void {
    this.game = new Phaser.Game(editorConfig);
    this.game.events.on("ready", () => {
      // Listen for the creation of the scene
      this.getEditorScene().onEditorCreated(() => {
        // Get the map id from the url
        const mapId = this.$route.params.mapId;
        if (mapId) {
          // Map edit mode
          world.getMap(mapId).then((map) => {
            if (!map) {
              // The map that we want to edit doesn't exist
              // TODO: Display error message
              this.$router.push("/admin");
              return;
            }

            this.editedMapId = mapId;
            this.mapSizeX = map.tileMap[0].length;
            this.mapSizeY = map.tileMap.length;
            this.mapName = map.name;

            try {
              this.getEditorScene().setMap(map);
            } catch (error) {
              // Display error message
              store.commit(commit.display, {
                type: MessageType.Red,
                title: "Error when loading the map",
                text: "The map you are trying to load is not valid"
              });
              console.error(error);
              this.$router.push("/admin");
            }
          });
        } else {
          // New map mode
          this.mapConfigPanel = true;
        }
      });

      // Listen for selected tile from the editor
      this.getEditorScene().onTileSelection((tileNumber: number) => {
        this.selectedTileNumber = tileNumber;
      });

      // Listen for selected spawn position from the editor
      this.getEditorScene().onSpawnPlaced(
        async(spawnPosition: [number, number]) => {
          if (this.spawnPositionMode && this.editedMapId !== null) {
            await world.setDefaultMap(this.editedMapId, spawnPosition);
            this.spawnPositionMode = false;
          }
        }
      );
    });
  }

  // Editor
  getEditorScene(): EditorScene {
    return this.game?.scene.getScene("EditorScene") as EditorScene;
  }

  selectedTile(tileNumber: number): void {
    this.selectedTileNumber = tileNumber;
    this.getEditorScene().setTileToPaint(tileNumber);
  }

  selectedEntity(entityName: string): void {
    if (entityName === this.selectedEntityName) this.selectedEntityName = null;
    else this.selectedEntityName = entityName;
  }

  @Watch("selectedEntityName")
  onEntityChange(): void {
    this.getEditorScene().setEntity(this.selectedEntityName);

    if (this.selectedEntityName) {
      this.wallHitboxMode = false;
      this.selectedLayerNumber = null;
      this.spawnPositionMode = false;
    }
  }

  @Watch("selectedLayerNumber")
  onLayerChange(): void {
    this.getEditorScene().setLayer(this.selectedLayerNumber);
    if (this.selectedLayerNumber) {
      this.wallHitboxMode = false;
      this.selectedEntityName = null;
      this.spawnPositionMode = false;
    }
  }

  @Watch("wallHitboxMode")
  onHitboxModeChange(): void {
    this.getEditorScene().setHitboxMode(this.wallHitboxMode);

    if (this.wallHitboxMode) {
      this.selectedLayerNumber = null;
      this.selectedEntityName = null;
      this.spawnPositionMode = false;
    }
  }

  @Watch("spawnPositionMode")
  onSpawnPositionModeChange(): void {
    this.getEditorScene().setSpawnPositionMode(this.spawnPositionMode);

    if (this.spawnPositionMode) {
      this.mapSetDefaultInfoPanel = true;
      this.selectedLayerNumber = null;
      this.selectedEntityName = null;
      this.wallHitboxMode = false;
    }
  }

  // Controls
  async saveMap(): Promise<void> {
    const mapToSave = this.getEditorScene().getMap();
    mapToSave.name = this.mapName;
    mapToSave.id = this.editedMapId;
    await world.saveMap(mapToSave);
    this.$router.push("/admin");
  }

  saveConfig(): void {
    this.mapSizeX = parseInt(this.mapSizeX.toString(), 10);
    this.mapSizeY = parseInt(this.mapSizeY.toString(), 10);
    this.mapConfigPanel = false;
    this.getEditorScene().setMapSize(this.mapSizeX, this.mapSizeY);
    this.wallHitboxMode = false;
  }

  // Exit
  beforeDestroy(): void {
    // Destroy the game instance
    this.game?.destroy(true);
  }
}
</script>

<style scoped>
#MapEditor {
  height: 100%;
  width: 100%;
  display: grid;
  grid-template-columns: 1fr;
  grid-template-rows: 80px 1fr;
  gap: 0px 0px;
  grid-template-areas:
    "menu"
    "editor";
  padding-top: 20px;
}

#menu {
  gap: 50px;
  align-items: center;
}
#menu #buttons {
  gap: 10px;
}

/* Layers */
#menu #layers {
  display: flex;
  gap: 10px;
  align-items: center;
}
#menu #layers #layerList {
  display: flex;
  gap: 2px;
}
#menu #layers #layerList button {
  width: 30px;
  height: 30px;
}
#menu #layers #playerLayer {
  margin: 2px 5px 2px 5px;
  padding: 0 5px 0 2px;
  font-weight: bold;
  opacity: 0.5;
}

/* Entities */
#menu #entities {
  display: flex;
  gap: 10px;
  align-items: center;
}

/* Tile selection & board */
#editor {
  height: 85vh;
  display: flex;
  flex-direction: row;
  gap: 5px;
}
#editor #tileList {
  flex: 2;
}
#editor #board {
  flex: 7;
}
</style>
